<?php
/*
* Class UniScyw
*
*
*/

class UniScyw {

	private $aResult 		= array(
									'status' 	=> 'error',
									'message' 	=> 'Error!'
	                            );
	protected $YClientID        = '';
	protected $YClientSecret    = '';
    protected $YRedirectUri     = '';

    function __construst() {
        $this->YClientID 	    = get_option('scyw_cliend_id');
        $this->YClientSecret	= get_option('scyw_cliend_secret');
        $this->YRedirectUri	    = rtrim( get_bloginfo('url'), '/' ).'/?yandex_oauth_callback=yes';

        add_action( 'admin_menu', array( $this, 'scyw_menu' ) );
        add_action( 'update_option_scyw_response_code', array( $this, 'callback_on_scyw_response_code' ), 10, 2 );
        add_action( 'publish_post', array( $this, 'send_data_to_original_texts' ) );
    }

    //
    function scyw_menu() {
	    add_options_page('SCYW', 'Send Content to Yandex Webmsater', 'manage_options', 'scyw-options', array( $this, 'scyw_options_function') );
        add_action( 'admin_init', array( $this, 'register_scyw_settings') );
    }

    //
    function callback_on_scyw_response_code( $oldvalue, $_newvalue ) {
        if ( empty($_newvalue) ) {
            delete_option('scyw_access_token');
            delete_option('scyw_expires_in');
            delete_option('scyw_chosen_site_id');
            delete_option('scyw_original_texts_url');
        }
    }

    //
    function register_scyw_settings() {
	    register_setting( 'scyw-first-step', 'scyw_cliend_id' );
	    register_setting( 'scyw-first-step', 'scyw_cliend_secret' );
	    register_setting( 'scyw-second-step', 'scyw_response_code' );
        register_setting( 'scyw-third-step', 'scyw_chosen_site_id' );
    }

    //
    public function scyw_options_function() {
        ?>

        <div class="wrap">
            <div id="icon-options-general" class="icon32"><br /></div>
            <h2><?php _e( 'Send content to Yandex.Webmasters', UNI_SCYW_DOMAIN ) ?></h2>

            <?php
            $this->save_id_and_secret();

            if ( $this->YClientID ) {
                $this->display_auth_link();
                $this->save_response_code();
            } else {
                _e( '<p>Авторизация невозможна пока не указан "Client ID".</p>', UNI_SCYW_DOMAIN );
            }

            if ( get_option('scyw_response_code') && !get_option('scyw_access_token') ) {
                $this->get_and_save_token();
            }
            ?>

            <?php if ( get_option('scyw_access_token') ) { ?>
                <p style="color:green;"><?php _e('Accesss token:', UNI_SCYW_DOMAIN) ?> <?php _e('получен', UNI_SCYW_DOMAIN) ?> (<?php echo get_option('scyw_access_token') ?>)</p>
            <?php } else { ?>
                <p style="color:red;"><?php _e('Accesss token:', UNI_SCYW_DOMAIN) ?> <?php _e('не получен', UNI_SCYW_DOMAIN) ?></p>
            <?php }
            if ( get_option('scyw_access_token') && get_option('scyw_expires_in') ) { ?>
                <p style="color:green;"><?php _e('Срок действия access token истекает:', UNI_SCYW_DOMAIN) ?> <?php echo date('Y-m-d', get_option('scyw_expires_in')); ?></p>
            <?php

                $this->display_sites_list();

                if ( get_option('scyw_access_token') && get_option('scyw_chosen_site_id') ) { ?>
                    <p style="color:green;"><?php _e('Выбран id:', UNI_SCYW_DOMAIN) ?> <?php echo get_option('scyw_chosen_site_id'); ?></p>
                <?php
                $aSiteInfo = $this->get_chosen_site_info();
                    if ( $aSiteInfo['status'] == 'error' ) {
                        echo $aSiteInfo['message'];
                    }
                } ?>

            <?php if ( get_option('scyw_original_texts_url') ) { ?>
                <p style="color:green;"><?php printf( __('Url сервиса "Оригинальние тексты" получен (%s)', UNI_SCYW_DOMAIN), get_option('scyw_original_texts_url') ) ?></p>
            <?php }

            } ?>

        </div>
        <?php
    }

    // форма збереження
    public function save_id_and_secret() {
      ?>
            <form method="post" action="options.php">
                <?php settings_fields( 'scyw-first-step' ); ?>
                <?php do_settings_sections( 'scyw-first-step' ); ?>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e( 'Укажите Id приложения', UNI_SCYW_DOMAIN ) ?></th>
                        <td><input type="text" name="scyw_cliend_id" value="<?php echo get_option('scyw_cliend_id'); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e( 'Укажите пароль приложения (секретный ключ)', UNI_SCYW_DOMAIN ) ?></th>
                        <td><input type="text" name="scyw_cliend_secret" value="<?php echo get_option('scyw_cliend_secret'); ?>" /></td>
                    </tr>
                </table>
                <?php submit_button(__( 'Сохранить id и ключ', UNI_SCYW_DOMAIN )); ?>
            </form>
    <?php
    }

    // виводимо лінк аутентифікації
    public function display_auth_link() {
            $aLinkArgs = array(
                    'response_type' => 'code',
                    'client_id'     => $this->YClientID,
                    'display'       => 'popup'
                );
            echo '<p><a target="_blank" class="button-primary" href="'. add_query_arg( $aLinkArgs, 'https://oauth.yandex.ru/authorize' ) .'">'.__( 'Авторизоваться в Яндекс', UNI_SCYW_DOMAIN ).'</a></p>';
            _e( '<p>Для дальнейшей работы требуется ваше разрешение. После согласия вам будет доступен код ответа. Вы должны скопировать код ответа и сохранить в форме ниже.</p>', UNI_SCYW_DOMAIN );
    }

    // "ловимо" code
    public function save_response_code() {
      ?>
            <form method="post" action="options.php">
                <?php settings_fields( 'scyw-second-step' ); ?>
                <?php do_settings_sections( 'scyw-second-step' ); ?>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e( 'Укажите код ответа', UNI_SCYW_DOMAIN ) ?></th>
                        <td><input type="text" name="scyw_response_code" value="<?php echo get_option('scyw_response_code'); ?>" />
                            <span class="description"><?php _e( 'Удаление значения кода ответа приведет также к удалению token\'a, идентификатора выбраного сайта и ссылки на сервис "Оригинальные тексты". Используйте этот прием, например, для обновления token\'a.', UNI_SCYW_DOMAIN ) ?></span>
                        </td>
                    </tr>
                </table>
                <?php submit_button(__( 'Сохранить код ответа', UNI_SCYW_DOMAIN )); ?>
            </form>
    <?php
    }

    // "ловимо" token
    public function get_and_save_token(){

        $aResult = $this->aResult;

        $sUrl = 'https://oauth.yandex.ru/token';
        $aPostHeaders = array(
                    'method' => 'POST',
                    'host' => 'oauth.yandex.ru',
                    'content-type' => 'application/x-www-form-urlencoded'
                    );
        $aPostData = array(
                'grant_type' => 'authorization_code',
                'code' => get_option('scyw_response_code'),
                'client_id' => $this->YClientID,
                'client_secret' => $this->YClientSecret
                );

        $aResult = wp_remote_post( $sUrl, array( 'headers' => $aPostHeaders, 'body' => $aPostData ) );

        if ( ! is_wp_error( $aResult ) ) {

            $ResponseBody = wp_remote_retrieve_body( $aResult );
            $oResponse = json_decode( $ResponseBody );

            if ( !$oResponse->error ) {
                update_option( 'scyw_access_token', $oResponse->access_token );
                $sExpiresInTimestamp = time() + $oResponse->expires_in;
                update_option( 'scyw_expires_in', $sExpiresInTimestamp );

            } else {
                print_r( 'Token: '.$oResponse->error );
            }

        } else {
            print_r( 'Token: '.$aResult->error );
        }

    }

    // отримуємо список сайтів
	public function get_sites_list() {

        $aResult = $this->aResult;

        if ( get_option("scyw_access_token") ) {

            //1. get user id
            $sUrl = 'https://webmaster.yandex.ru/api/v2';
            $aResultMe = wp_remote_get( $sUrl, array( 'headers' => array( 'Authorization' => 'OAuth '.get_option( 'scyw_access_token' ) ), 'httpversion' => '1.1' ) );

            if ( ! is_wp_error( $aResultMe ) ) {

            if ( $aResultMe['response']['code'] != 200 ) {
                $aResult['status'] = 'error';
                $aResult['message'] = 'Api /me status code not 200: '.$aResultMe['response']['message'];
                return $aResult;
            } else {

                $ResponseBody = wp_remote_retrieve_body( $aResultMe );
                $oXmlParsed = simplexml_load_string($ResponseBody);
                if ( $oXmlParsed && !$oXmlParsed->error ) {
                    $sHostsHref = $this->xml_attribute($oXmlParsed->workspace->collection[0], 'href');

                    update_option('scyw_hosts_href', $sHostsHref);

                    //2. get sites list
                    $sSitesUrl = get_option('scyw_hosts_href');
                    $aResultSites = wp_remote_get( $sSitesUrl, array( 'headers' => array( 'Authorization' => 'OAuth '.get_option( 'scyw_access_token' ) ), 'httpversion' => '1.1' ) );

                    if ( $aResultSites['response']['code'] != 200 ) {
                        $aResult['status'] = 'error';
                        $aResult['message'] = 'Api /hosts: '.$aResultSites['response']['message'];
                        return $aResult;
                    } else {

                        $ResponseHostsBody = wp_remote_retrieve_body( $aResultSites );
                        $oXmlHostsParsed = simplexml_load_string($ResponseHostsBody);
                        if ( $oXmlHostsParsed && !$oXmlHostsParsed->error ) {
                            $aResult['status'] = 'success';
                            $aResult['result'] = $oXmlHostsParsed;
                            return $aResult;
                        } else {
                            $aResult['status'] = 'error';
                            $aResult['message'] = 'Api /hosts parse error: '.$oXmlHostsParsed->error;
                            return $aResult;
                        }

                    }

                } else {
                    $aResult['status'] = 'error';
                    $aResult['message'] = 'Api /me parse: '.$oXmlParsed->error;
                    return $aResult;
                }

            }

            } else {
                $aResult['status'] = 'error';
                $aResult['message'] = 'Api /me: '.$aResultMe->errors;
                return $aResult;
            }

        } else {
            $aResult['status'] = 'error';
            $aResult['message'] = 'No access token';
            return $aResult;
        }

    }

    // показуємо список сайтів
	public function display_sites_list() {

        $oSitesList = $this->get_sites_list();

        if ( $oSitesList['status'] == 'error' ) {
            echo $oSitesList['message'];
        } else {

            $oSites = $oSitesList['result'];
        ?>
            <form method="post" action="options.php">
                <?php settings_fields( 'scyw-third-step' ); ?>
                <?php do_settings_sections( 'scyw-third-step' ); ?>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e( 'Выберите сайт', UNI_SCYW_DOMAIN ) ?></th>
                        <td>
                            <select name="scyw_chosen_site_id">
                                <option value=""<?php selected('', get_option('scyw_chosen_site_id'), false) ?>>&nbsp;</option>
                    <?php foreach ( $oSites->host as $oItem ) {

                        $sSiteHrefAttr = $this->xml_attribute($oItem[0], 'href');
                        $sSiteId = str_replace( get_option('scyw_hosts_href').'/', '', $sSiteHrefAttr );
                        $sSiteDomain = $oItem->name;
                        $sSiteVerification = $this->xml_attribute($oItem->verification[0], 'state');

                        echo '<option class="level-0" value="'.$sSiteId.'"'.selected($sSiteId, get_option('scyw_chosen_site_id'), false).'>'.$sSiteDomain.' (статус: '.$sSiteVerification.'; id: '.$sSiteId.')</option>';
                    } ?>
                            </select>
                        </td>
                    </tr>
                </table>
                <?php submit_button(__( 'Сохранить выбраный сайт', UNI_SCYW_DOMAIN )); ?>
            </form>
    <?php
        }

    }

    // інформація про вибраний сайт і збереження урл для "original-texts"
	public function get_chosen_site_info() {

        $aResult = $this->aResult;

        if ( get_option("scyw_access_token") && get_option('scyw_chosen_site_id') ) {

            //1. get site info
            $sUrl = get_option('scyw_hosts_href').'/'.get_option('scyw_chosen_site_id');
            $aResultSite = wp_remote_get( $sUrl, array( 'headers' => array( 'Authorization' => 'OAuth '.get_option( 'scyw_access_token' ) ), 'httpversion' => '1.1', 'sslverify' => false ) );

            if ( $aResultSite['response']['code'] != 200 ) {
                $aResult['status'] = 'error';
                $aResult['message'] = $aResultSite['response']['message'];
                return $aResult;
            } else {

                $ResponseBody = wp_remote_retrieve_body( $aResultSite );
                $oXmlParsed = simplexml_load_string($ResponseBody);
                if ( $oXmlParsed && !$oXmlParsed->error ) {

                    foreach ( $oXmlParsed->link as $oResource ) {
                        $sSiteHrefAttr = $this->xml_attribute($oResource, 'href');
                        $sTrimmedHref = rtrim($sSiteHrefAttr,'/');
                        $sResourceName = str_replace( $sUrl.'/', '', $sTrimmedHref );
                        if ( $sResourceName == 'original-texts' ) {
                            update_option('scyw_original_texts_url', $sSiteHrefAttr);
                            $aResult['status'] = 'success';
                            return $aResult;
                        }
                    }

                } else {
                    $aResult['status'] = 'error';
                    $aResult['message'] = 'Api /resources: '.$oXmlParsed->error;
                    return $aResult;
                }

            }

        } else {
            $aResult['status'] = 'error';
            $aResult['message'] = 'Нет информации о выбраном сайте';
            return $aResult;
        }

    }

    // get xml attribute
    function xml_attribute($object, $attribute){
        if(isset($object[$attribute]))
            return (string) $object[$attribute];
    }

    //***********************************************************************************

    //
    public function send_data_to_original_texts( $post_id ) {

        global $UniLog;

        if ( get_option("scyw_access_token") && get_option("scyw_original_texts_url") ) {
            $sOriginalText = $this->get_original_text_for_post(30000, $post_id);
            $sOriginalTextEncoded = urlencode($sOriginalText);
            $sOriginalTextEncoded = '<original-text><content>'.$sOriginalTextEncoded.'</content></original-text>';

            /**/$UniLog->logInfo('Sending post data to Yandex Webmaster Original texts have started for post ID: ', $post_id);
            /**/$UniLog->logInfo('Original text have prepared: ', $sOriginalTextEncoded);

            $sTextsLength = strlen($sOriginalText);
            /**/$UniLog->logInfo('Length of string is: ', $sTextsLength);
            if ( $sTextsLength < 500 || $sTextsLength > 32000 ) {
                /**/$UniLog->logInfo('Error. Min length is 500 and max length is 32000!');
                /**/$UniLog->logInfo('======================ERROR=============================');
                return;
            }

            $sUrl = get_option("scyw_original_texts_url");

            $aPostHeaders = array(
                    'method' => 'POST',
                    'host' => 'webmaster.yandex.ru',
                    'content-type' => 'application/xml',
                    'Authorization' => 'OAuth '.get_option( 'scyw_access_token' ),
                    'Content-Length' => $sTextsLength
                    );

            $aResult = wp_remote_post( $sUrl, array( 'headers' => $aPostHeaders, 'body' => $sOriginalTextEncoded, 'httpversion' => '1.1', 'sslverify' => false ) );

            if ( !is_wp_error( $aResult ) && ($aResult['response']['code'] == 201) ) {

                $ResponseBody = wp_remote_retrieve_body( $aResult );

                /**///$UniLog->logInfo('Here is body of response: ', $ResponseBody);
                if ( $ResponseBody ) {
                    $oXmlParsed = simplexml_load_string($ResponseBody);
                    if ( $oXmlParsed && !$oXmlParsed->error ) {

                        $aData = array();
				        $aData['post_id'] = $post_id;
                        $aData['webmaster_id'] = $oXmlParsed->id;
                        $aData['webmaster_url'] = $this->xml_attribute($oXmlParsed->link, 'href');

                        /**/$UniLog->logInfo('We have recieved successful response. Your text is added.');
                        $bSaved = $this->save_original_text_response( $aData );
                        if ( $bSaved ) {
                            /**/$UniLog->logInfo('Congrats! Response has saved in our DB.');
                            /**/$UniLog->logInfo('======================SUCCESS=============================');
                        } else {
                            /**/$UniLog->logInfo('There was an error while saving response in DB.');
                            /**/$UniLog->logInfo('======================ERROR=============================');
                        }
                    } else {
                        /**/$UniLog->logInfo('Parsing error: ', $oXmlParsed->error);
                        /**/$UniLog->logInfo('======================ERROR=============================');
                    }
                } else {
                    /**/$UniLog->logInfo('Response error. Have a look on it: ', $ResponseBody);
                    /**/$UniLog->logInfo('======================ERROR=============================');
                }

            } else {
                /**/$UniLog->logInfo('Error while performing remote post: ', $aResult);
                /**/$UniLog->logInfo('======================ERROR=============================');
            }

        }

    }

    //
    function get_original_text_for_post($length, $postid) {
        $content_post = get_post($postid);
        $content = $content_post->post_content;
                $text = apply_filters('the_content', $content);
                $text = str_replace('\]\]\>', ']]&gt;', $text);
                $text = preg_replace('@<script[^>]*?>.*?</script>@si', '', $text);
                $text = strip_tags($text, '<img />');
                $excerpt = substr($text, 0, $length);
        return $excerpt;
    }

    //
    function save_original_text_response( $aData ) {
        global $wpdb;
	    $sql = $wpdb->prepare(
                        "INSERT INTO ".$wpdb->prefix."scyw_original_texts
                        ( post_id, webmaster_id, webmaster_url )
                        VALUES ( %d, %s, %s )",
				    $aData['post_id'],
                    $aData['webmaster_id'],
                    $aData['webmaster_url']
                );

		$sResult = $wpdb->query($sql);

        return $sResult;
    }

}

?>